org.apache.felix.ipojo.manipulator.metadata.annotation.visitor.generic

## Class GenericVisitor

- java.lang.Object
- - org.objectweb.asm.AnnotationVisitor
  - - org.apache.felix.ipojo.manipulator.metadata.annotation.visitor.generic.GenericVisitor

Direct Known Subclasses:
  RootGenericVisitor

    public class GenericVisitor
    extends org.objectweb.asm.AnnotationVisitor

Author:
  Felix Project Team

### Field Summary

Fields
`protected org.apache.felix.ipojo.metadata.Element` `element`

### Fields inherited from class org.objectweb.asm.AnnotationVisitor

`api, av`

### Constructor Summary

Constructors
Constructor and Description
`GenericVisitor(org.apache.felix.ipojo.metadata.Element element)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `visit(String name, Object value)` Visit a 'simple' annotation attribute.
`org.objectweb.asm.AnnotationVisitor` `visitAnnotation(String name, String descriptor)` Visit a sub-annotation.
`org.objectweb.asm.AnnotationVisitor` `visitArray(String name)` Visit an array attribute.
`void` `visitEnum(String name, String desc, String value)` Visits an enumeration attribute.

### Methods inherited from class org.objectweb.asm.AnnotationVisitor

`getDelegate, visitEnd`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### element

    protected org.apache.felix.ipojo.metadata.Element element

### Constructor Detail

#### GenericVisitor

    public GenericVisitor(org.apache.felix.ipojo.metadata.Element element)

### Method Detail

#### visit

    public void visit(String name,
                      Object value)

Visit a 'simple' annotation attribute. This method is used for primitive arrays too.

Overrides:
  `visit` in class `org.objectweb.asm.AnnotationVisitor`
Parameters:
  `name` - : attribute name
  `value` - : attribute value
See Also:
  `AnnotationVisitor.visit(String, Object)`

#### visitAnnotation

    public org.objectweb.asm.AnnotationVisitor visitAnnotation(String name,
                                                               String descriptor)

Visit a sub-annotation.

Overrides:
  `visitAnnotation` in class `org.objectweb.asm.AnnotationVisitor`
Parameters:
  `name` - : attribute name.
  `descriptor` - : annotation description
Returns:
  an annotation visitor which will visit the given annotation
See Also:
  `AnnotationVisitor.visitAnnotation(String, String)`

#### visitArray

    public org.objectweb.asm.AnnotationVisitor visitArray(String name)

Visit an array attribute.

Overrides:
  `visitArray` in class `org.objectweb.asm.AnnotationVisitor`
Parameters:
  `name` - : attribute name
Returns:
  a visitor which will visit each element of the array
See Also:
  `AnnotationVisitor.visitArray(String)`

#### visitEnum

    public void visitEnum(String name,
                          String desc,
                          String value)

Visits an enumeration attribute.

Overrides:
  `visitEnum` in class `org.objectweb.asm.AnnotationVisitor`
Parameters:
  `name` - the attribute name
  `desc` - the enumeration descriptor
  `value` - the attribute value
See Also:
  `AnnotationVisitor.visitEnum(String, String, String)`